new;
library pgraph;

let sigma  = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;
let mu     = 5.00	1.00	5.00	2.50	5.00	7.50	10.00;

sharpe = mu ./ sigma;

mu = mu / 100;
sigma = sigma / 100;

n = rows(mu);
rho = eye(n);

cov = sigma .* sigma' .* rho;

Q = 2*cov;
R = mu;

A = ones(1,n); B = 1;
C = 0; D = 0;
bounds = ones(n,1) .* (0~1);

sv = ones(n,1)/n;

phi = seqa(-2,0.005,601);
nPhi = rows(phi);
er = zeros(nPhi,1);
vol = zeros(nPhi,1);

i = 1;
do until i > nPhi;
  {x,u1,u2,u3,u4,retcode} = QProg(sv,Q,phi[i]*R,A,B,C,D,bounds);
  er[i] = x'mu;
  vol[i] = sqrt(x'cov*x);
  i = i + 1;
endo;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  xlabel("\216Risk");
  ylabel("\216Expected Return");
  xy(100*vol,100*er);


