new;
library optmum,pgraph;

#include regGMM.src
#include regHeston.src

cls;

S0 = 100;
V0 = 0.20^2;
muS = 0.05;
kappa = 1;
muV = V0;
epsilon = 0.20;
rho = 0.0;

dt = 1/260;
t = seqa(0,dt,5/dt);

rndseed 123;

Ns = 1;
{S,V} = rndHeston(S0,V0,muS,kappa,muV,epsilon,rho,t,Ns,1);

proc (6) = ThetaProc(theta);
  local V0,muS,muV,kappa,epsilon,rho;

  muS = theta[1];
  V0 = theta[2]^2;
  muV = theta[2]^2;
  kappa = 1;
  epsilon = sqrt(theta[3]^2);
  rho = 2*sqrt(theta[4]^2)-1;

  retp(V0,muS,muV,kappa,epsilon,rho);
endp;
sv = 0.0|0.20|0.20|0.6;

{V0,muS,muV,kappa,epsilon,rho} = regHestonSMM(S,dt,sv,&ThetaProc,1);
