new;

#include spectral.src

sigma = 1;
x = rndn(1000,1)*sigma;

{lambda,I} = PDGM(x);

proc mlfn(theta);
  local sigma,g,logl;

  sigma = sqrt(theta^2);
  g = sigma^2;
  logl = -0.5*ln(2*pi) - 0.5*ln(g) - 0.5*(I./g);

  retp(logl);
endp;

fn NegLoglik(theta) = -sumc(mlfn(theta));

{theta,fmin,grd,retcode} = optmum(&NegLogLik,0.5);
sigma = sqrt(theta^2);

cls;

print "Estimated FDML sigma = " sigma;
print "Empirical std dev = " stdc(x);


